#include <bits/stdc++.h>

using namespace std;

void solve();

// #include<ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_pbds;
// using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
#pragma GCC optimize("O3,Ofast,unroll-loops")

int main() {
#ifdef LOCAL
    freopen("input.txt", "r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}

#define int long long
#define endl '\n'
const int N = 1e5+100, MOD = 998244353, INF = 2e18;
const double EPS = 1e-6, pi = acos(-1);
int add(int a,int b) {
    if (a+b>=MOD)return a+b-MOD;
    return a+b;
}
int sub(int a,int b) {
    if (a-b<0)return a-b+MOD;
    return a-b;
}
int mul(int a,int b) {
    return (a*b)%MOD;
}

void solve() {
    int t;
    cin>>t;
    int n,m;
    cin>>n>>m;
    vector<int> a(n);
    set<int> st;
    for (int i=0;i<n;i++) {
        cin>>a[i];
        st.insert(a[i]%2);
    }
    string s;
    cin>>s;
    if (st.size()==2) {
        cout<<"No"<<endl;
        return;
    }
    cout<<"Yes"<<endl;
    if (t==1)return;
    int inpos=(m-1)/2;
    cout<<inpos+1<<endl;
    if (t==2)return;
    cout<<1<<endl;
    cout<<inpos<<" "<<inpos+1<<endl;
}
